diff mbox series

[4/9,v2] Add replace-spdx-license.sh script

Message ID 87d04wlsk8.fsf@redhat.com
State New
Headers show
Series Relicensing Libabigail to Apache 2.0 + LLVM Exception | expand

Commit Message

Dodji Seketeli July 15, 2020, 3:13 p.m. UTC
This script is to replace an SPDX license ID by another one.
I.e, it's to perform an actual re-licensing of a given file.

A way to use the script is this:

    replace-spdx-license.sh  --from LGPL-3.0-or-later \
			      --to  "Apache-2.0 WITH LLVM-exception" \
			      some-file-to-relicense.cc

	* relicensing-scripts/replace-spdx-license.sh: New script.

Signed-off-by: Dodji Seketeli <dodji@redhat.com>
Signed-off-by: Matthias Maennich <maennich@google.com>
---
 relicensing-scripts/replace-spdx-license.sh | 75 +++++++++++++++++++++++++++++
 1 file changed, 75 insertions(+)
 create mode 100755 relicensing-scripts/replace-spdx-license.sh

Comments

Jonathan Wakely July 16, 2020, 10:27 a.m. UTC | #1
On 15/07/20 17:13 +0200, Dodji Seketeli wrote:
>This script is to replace an SPDX license ID by another one.
>I.e, it's to perform an actual re-licensing of a given file.
>
>A way to use the script is this:
>
>    replace-spdx-license.sh  --from LGPL-3.0-or-later \
>			      --to  "Apache-2.0 WITH LLVM-exception" \
>			      some-file-to-relicense.cc
>
>	* relicensing-scripts/replace-spdx-license.sh: New script.
>
>Signed-off-by: Dodji Seketeli <dodji@redhat.com>
>Signed-off-by: Matthias Maennich <maennich@google.com>

Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
Dodji Seketeli July 16, 2020, 4:20 p.m. UTC | #2
Jonathan Wakely <jwakely@redhat.com> writes:

> On 15/07/20 17:13 +0200, Dodji Seketeli wrote:
>>This script is to replace an SPDX license ID by another one.
>>I.e, it's to perform an actual re-licensing of a given file.
>>
>>A way to use the script is this:
>>
>>    replace-spdx-license.sh  --from LGPL-3.0-or-later \
>>			      --to  "Apache-2.0 WITH LLVM-exception" \
>>			      some-file-to-relicense.cc
>>
>>	* relicensing-scripts/replace-spdx-license.sh: New script.
>>
>>Signed-off-by: Dodji Seketeli <dodji@redhat.com>
>>Signed-off-by: Matthias Maennich <maennich@google.com>
>
> Signed-off-by: Jonathan Wakely <jwakely@redhat.com>

Applied, thanks.  It's going to show up in the v3 set of patches.  Until
then you can see this in the relicensing branch that can be browsed at
https://sourceware.org/git/?p=libabigail.git;a=shortlog;h=refs/heads/relicensing.

Cheers,
diff mbox series

Patch

diff --git a/relicensing-scripts/replace-spdx-license.sh b/relicensing-scripts/replace-spdx-license.sh
new file mode 100755
index 0000000..f634528
--- /dev/null
+++ b/relicensing-scripts/replace-spdx-license.sh
@@ -0,0 +1,75 @@ 
+#!/bin/sh
+# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
+# Author: Dodji Seketeli <dodji@redhat.com>
+
+from_license_id=
+to_license_id=
+input_file=
+prog=$0
+
+display_usage()
+{
+    echo "$prog: [options] --from <from-spdx-license-id> --to <to-spdx-license-id> <file>"
+    echo "  where options can be:"
+    echo "   -h|--h		display this help"
+}
+
+main()
+{
+    header=$(head --lines=5 $input_file | grep "SPDX-License-Identifier:")
+    if test "x$header" != x; then
+	license=$(echo "$header" | sed -r "s/^.*(SPDX-License-Identifier:)[ 	]*([^*/]+).*$/\2/")
+    fi
+
+    if test "x$license" != x -a "$license" = "$from_license_id"; then
+	sed -i -r "s/$from_license_id/$to_license_id/" $input_file
+	exit 0
+    fi
+
+    exit 1
+}
+
+# This program takes at least 5 arguments
+if test $# -lt 5; then
+    >&2 display_usage
+    exit 1
+fi
+
+# Parse parameters
+while test $# -gt 1; do
+    case "$1" in
+	-h|--h)
+	    display_usage
+	    exit 0
+	    ;;
+
+	-f|--from)
+	    from_license_id=$2
+	    shift
+	    ;;
+
+	-t|--to)
+	    to_license_id=$2
+	    shift
+	    ;;
+
+	-*)
+	    >&2 display_usage
+	    exit 1
+	    ;;
+
+	*)
+	    input_file="$1"
+	    ;;
+    esac
+    shift
+done
+
+if test $# -lt 1; then
+    >&2 display_usage
+    exit 1
+fi
+
+input_file=$1
+
+main